/*
	$Id: BIM.cpp,v 1.28 2003/05/14 12:03:14 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#define TARGET_API_MAC_CARBON 1

#define kMENU_Pencil (kBaseResourceID + 1)

#include <Carbon/Carbon.h>
#include <string.h>
#include <stdio.h>

#include "BIM.h"
#include "BIMInputEvents.h"
#include "BIMClientServer.h"
#include "BIMScript.h"
#include "IMSessionInputMode.h"
#include "CppCFString.h"
#include "ServerConnectionFactory.h"
#include "ClientConfiguration.h"
#include "ClientMessageReceiver.h"
#include "SkkConfig.h"

#if 0
#	define D_PRINTF printf
#else
#	define D_PRINTF if(0)printf
#endif

enum {
	kAboutSKKMenuCommand = 'ABOU',
	kPreferencesMenuCommand = 'PREF',
	kRegisterWordMenuCommand = 'RGWR'
};

static BIMSessionHandle gActiveSession;
static MenuRef gPencilMenu;
static Handle* gIcons; // gIcons = new Handle[k_ICON_INDEX_END_];

static pascal OSStatus BIMPencilMenuEventHandler( EventHandlerCallRef inEventHandlerCallRef,
                                                  EventRef inEventRef, void *inUserData );

// O[oȒlAMj[\zB
ComponentResult BIMInitialize( ComponentInstance inComponentInstance,
                               MenuRef *outTextServiceMenu )
{
    ComponentResult result;
    short refNum;
    EventTypeSpec menuEventSpec;
    
    result = noErr;
    refNum = -1;
    
    gActiveSession = NULL;
    gPencilMenu = NULL;
    
    //  INĂȂNB
	ServerConnectionFactory::sharedFactory().prepareServer();

    //	̃R|[lg̃\[Xt@CJB
    if( result == noErr ) {
        refNum = OpenComponentResFile( (Component) inComponentInstance );
        result = ResError();
        if( ( result == noErr ) && ( refNum == -1 ) )
            result = resFNotFound;
    }
    
	//	Mj[p̃ACRSă[hA؂藣B
	gIcons = new Handle[k_ICON_INDEX_END_];
	for (int i = 0;i < k_ICON_INDEX_END_;i++)
	{
		NewIconSuite(&gIcons[i]);
		Handle icon;
		
		icon = GetResource('ics8',kBaseResourceID+1+i);
		DetachResource(icon);
		AddIconToSuite(icon,gIcons[i],'ics8');
		
		icon = GetResource('ics4',kBaseResourceID+1+i);
		DetachResource(icon);
		AddIconToSuite(icon,gIcons[i],'ics4');
		
		icon = GetResource('ics#',kBaseResourceID+1+i);
		DetachResource(icon);
		AddIconToSuite(icon,gIcons[i],'ics#');
	}
	
	// ^CǵuȁvACRB
	Str255 menuTitle;
	menuTitle[0] = 5;
	menuTitle[1] = 1;
	*(reinterpret_cast<Handle*>(&menuTitle[2])) = gIcons[kHiraganaIconIndex];
	gPencilMenu = NewMenu(kBaseResourceID,menuTitle);
	*outTextServiceMenu = gPencilMenu;
	
	// ڂ̃^Cg쐬B
	// قǋȃn[hR[hǂƎvAt@Cēǂ܂͖̂ʓ|B
	CppCFString about; // AquaSKKɂ...
	about.append("AquaSKK").append(0x306b).append(0x3064).append(0x3044).append(0x3066).append("...");
	CppCFString separator; // -
	separator.append('-');
	CppCFString preferences; // ݒ...
	preferences.append(0x74b0).append(0x5883).append(0x8a2d).append(0x5b9a).append("...");
	CppCFString register_word; // Po^...
	register_word.append(0x5358).append(0x8a9e).append(0x767b).append(0x9332).append("...");
	
	// ڂ̃^CgretainB̊֐IƓCFStringRefreleaseĂ܂߁B
	// {͂ȂƂCFStringRef𕡐ׂc
	// ccAppendMenuItemTextWithCFStringretain邩Rs[ĂꂻȂ̂łAĂ邩ǂ͕ȂB
	CFRetain(about.getString());
	CFRetain(separator.getString());
	CFRetain(preferences.getString());
	CFRetain(register_word.getString());
	
	// ڍ쐬
	// kMenuItemAttrDisabled,kMenuItemAttrSeparatorȂǂLB
	AppendMenuItemTextWithCFString(gPencilMenu,about.getString(),0,kAboutSKKMenuCommand,NULL);
	AppendMenuItemTextWithCFString(gPencilMenu,separator.getString(),kMenuItemAttrSeparator,'----',NULL);
	AppendMenuItemTextWithCFString(gPencilMenu,preferences.getString(),0,kPreferencesMenuCommand,NULL);
    AppendMenuItemTextWithCFString(gPencilMenu,separator.getString(),kMenuItemAttrSeparator,'----',NULL);
	AppendMenuItemTextWithCFString(gPencilMenu,register_word.getString(),kMenuItemAttrDisabled,kRegisterWordMenuCommand,NULL);
	// O`O`c@CppMenuRef낤c
	
    //  ctrl̃OtMɁB
    if( result == noErr )
        ChangeMenuAttributes( gPencilMenu, kMenuAttrUsePencilGlyph, 0 );
    
    //	Mj[̃CxgnhCXg[B
    if( result == noErr ) {
        menuEventSpec.eventClass = kEventClassCommand;
        menuEventSpec.eventKind = kEventProcessCommand;
        result = InstallMenuEventHandler( gPencilMenu,
                                          NewEventHandlerUPP( BIMPencilMenuEventHandler ), 1,
                                          &menuEventSpec, nil, nil );
    }
    
    //	R|[lg̃\[Xt@CB
    if( refNum != -1 )
        CloseComponentResFile( refNum );
    
    //  bZ[WM@\
	ClientMessageReceiver::start();

    return result;
}


// Mj[̃ACRݒ肷B
void BIMSetPencilMenuIcon(int menu_icon_index)
{
	Str255 menuText;
	menuText[0] = 5;
	menuText[1] = 1;
	*(Handle *)( &menuText[2] ) = gIcons[menu_icon_index];
	SetMenuTitle(gPencilMenu,menuText);
}

// Ō̃CX^Xj鎞ɌĂ΂B
void BIMTerminate( ComponentInstance inComponentInstance )
{    
    gActiveSession = NULL;
    gPencilMenu = NULL;
}

#pragma mark -

// VɃZbVJnB
ComponentResult BIMSessionOpen( ComponentInstance inComponentInstance,
                                BIMSessionHandle *outSessionHandle )
{
    ComponentResult result = noErr;
    
    if( result == noErr )
	{
        if( *outSessionHandle == nil )
            *outSessionHandle =( BIMSessionHandle ) NewHandle( sizeof( BIMSessionRecord ) );
        if( *outSessionHandle )
		{
            ( **outSessionHandle )->fComponentInstance = inComponentInstance;
            ( **outSessionHandle )->fLastUpdate = 0;
			( **outSessionHandle )->fLastUpdateLength = 0;
            ( **outSessionHandle )->fInputBufferCount = 0;
            ( **outSessionHandle )->fInputBuffer = NULL;
			(**outSessionHandle)->terminate_disabled = false;
			(**outSessionHandle)->imsession_input_mode = new IMSessionInputMode(*outSessionHandle);
			
			(**outSessionHandle)->imsession_input_mode->updatePencilMenuIcon();
        }
        else
            result = memFullErr;
    }
        
    //	Cvbgobt@
    if( result == noErr ) {
        ( **outSessionHandle )->fInputBuffer = (UniCharPtr) NewPtr( 1024 );
        result = MemError();
    }

    return result;
}

// ZbVjB
void BIMSessionClose( BIMSessionHandle inSessionHandle )
{	
    if( inSessionHandle )
	{
        if( ( *inSessionHandle )->fInputBuffer )
            DisposePtr( (Ptr) ( *inSessionHandle )->fInputBuffer );
		
		delete (*inSessionHandle)->imsession_input_mode;
		
        DisposeHandle( (Handle) inSessionHandle );
    }
}

// ZbVANeBuɂȂB
ComponentResult BIMSessionActivate( BIMSessionHandle inSessionHandle )
{
    gActiveSession = inSessionHandle;
    /*
        AquaSKKIÕL[̓XNvgLɂB
        ̏ȂDvorak,Dvorak - QwertyLɂȂȂB
        AtȂ̂Ő͂킩ȂB
    */
    long keyboardID = GetScriptVariable(GetScriptManagerVariable(smKeyCache), smScriptKeys);
    SetScriptVariable (smJapanese, smScriptKeys, keyboardID);
    
	// ANeBuɂȂIɓ`B
	ServerConnectionFactory::sharedFactory().newConnection().send(kBasicMessageActivated);
	
	ClientConfiguration::sharedConfiguration().reloadConfiguration(); // ݒ[h
	
    //return result;
	return 0;
}

// ZbVANeBułȂȂB
ComponentResult BIMSessionDeactivate( BIMSessionHandle inSessionHandle )
{	
    gActiveSession = nil;
	
	// ANeBułȂȂIɓ`B
	ServerConnectionFactory::sharedFactory().newConnection().send(kBasicMessageDeactivated);
	return 0;
}

// R|[lg̃CxgB
ComponentResult BIMSessionEvent( BIMSessionHandle inSessionHandle, EventRef inEventRef )
{
    Boolean handled;
    UInt32 eventClass;
    UInt32 eventKind;

    handled = FALSE;

    //  eventClasseventKind擾B
    eventClass = GetEventClass( inEventRef );
    eventKind = GetEventKind( inEventRef );

    if( eventClass == kEventClassKeyboard && ( eventKind == kEventRawKeyDown ||
                                               eventKind == kEventRawKeyRepeat ) )
	{
        UInt32 keyCode;
        unsigned char charCode;
        UInt32 modifiers;
        
        //  L[R[h擾
        GetEventParameter( inEventRef, kEventParamKeyCode, typeUInt32, nil, sizeof (keyCode),
                           nil, &keyCode );
        
        //  LN^R[h擾
        GetEventParameter( inEventRef, kEventParamKeyMacCharCodes, typeChar, nil,
                           sizeof( charCode ), nil, &charCode );

        //  fBt@CȀԂ擾
        GetEventParameter( inEventRef, kEventParamKeyModifiers, typeUInt32, nil,
                           sizeof( modifiers ), nil, &modifiers );
		
		D_PRINTF("mod: %lx , keycode: %lx, char: %c,%x\n",modifiers,keyCode,charCode,charCode);
		
		if (modifiers & (1 << cmdKeyBit)) // R}hL[ĂB
		{
			handled = false;
		}
		else if (keyCode == 0x66) // p
		{
            if (SkkConfig::config().useEisuuToSetHenkanPoint())
                handled = BIMHandleInput(inSessionHandle, SkkConfig::config().setHenkanPointKey());
            else
                handled = BIMHandleInput(inSessionHandle, SkkConfig::config().latinModeKey());
		}
		else if (keyCode == 0x68) // 
		{
            if (SkkConfig::config().useKanaToSetHenkanPoint())
                handled = BIMHandleInput(inSessionHandle, SkkConfig::config().setHenkanPointKey());
            else
                handled = BIMHandleInput(inSessionHandle, SkkConfig::config().kanaModeKey());
		}
		else
		{
			handled = BIMHandleInput(inSessionHandle,charCode);
		}
    }
    return handled;
}

// TSMmw󂯂
ComponentResult BIMSessionFix( BIMSessionHandle inSessionHandle )
{
    ComponentResult result;
	
	if (!(*inSessionHandle)->terminate_disabled)
	{
		(*inSessionHandle)->imsession_input_mode->terminate();
	}
	
    if( ( *inSessionHandle )->fInputBufferCount ) {
        result = BIMUpdateActiveInputArea( inSessionHandle, TRUE );
        ( *inSessionHandle )->fLastUpdateLength = 0;
        ( *inSessionHandle )->fInputBufferCount = 0;
    }
    return result;
}

// pbgB
ComponentResult BIMSessionHidePalettes( BIMSessionHandle inSessionHandle )
{
	ServerConnectionFactory::sharedFactory().newConnection().send(kBasicMessageHidePalettes);
	return 0;
}

#pragma mark -

// ANeBuȃZbVԂB
BIMSessionHandle BIMGetActiveSession( void )
{
    return gActiveSession;
}

// ̓͂ɑ΂Ă̏B
Boolean BIMHandleInput( BIMSessionHandle inSessionHandle, unsigned char inCharCode )
{
    Boolean handled = FALSE;
    
    switch( inCharCode )
	{
		case 0: // ̃L[͖
			handled = TRUE;
			break;
		
        case 0x08: // obNXy[X
			handled = (*inSessionHandle)->imsession_input_mode->handleBackSpace();
			break;

        case 0x03: // ^[
        case 0x0D:
            //skk-egg-like-newline ^ŕϊ[h()ł΁AC-j́B
            /*if( ClientConfiguration::sharedConfiguration().isSkkEggLikeNewline() == true &&
                (*inSessionHandle)->imsession_input_mode->isHenkanMode() == true )
			{
                inCharCode = kCj;
                (*inSessionHandle)->imsession_input_mode->handleInput(inCharCode);
				handled = TRUE;
            }
			else
			{*/
                handled = (*inSessionHandle)->imsession_input_mode->handleReturn();
			//}
			break;
            
        default:
			if (inCharCode >= 0x1c && inCharCode <= 0x1f) // 
			{
				int kind;
				switch (inCharCode) {
					case 0x1c: kind = InputMode::ARROW_LEFT; break;
					case 0x1e: kind = InputMode::ARROW_UP; break;
					case 0x1d: kind = InputMode::ARROW_RIGHT; break;
					case 0x1f: kind = InputMode::ARROW_DOWN; break;
				}
				handled = (*inSessionHandle)->imsession_input_mode->handleArrow(kind);
			}
			else if (SkkConfig::config().isCancelKey(inCharCode))
			{
				handled = (*inSessionHandle)->imsession_input_mode->handleCg();
			}
			else if (SkkConfig::config().isPasteKey(inCharCode))
			{
				handled = (*inSessionHandle)->imsession_input_mode->handleCy();
			}
			else if (inCharCode == '\t') // Tab
			{
				handled = (*inSessionHandle)->imsession_input_mode->handleTab();
			}
			else if ((inCharCode >= 0x20 && inCharCode <= 0x7e) // AXL[pL͈̔
					|| SkkConfig::config().isMappedKey(inCharCode))
			{
				(*inSessionHandle)->imsession_input_mode->handleInput(inCharCode);
				handled = TRUE;
			}
			break;
    }
    
    //obt@̒l0Ȃ狭IɃt[eBOEBhE
    if( ( *inSessionHandle )->fInputBufferCount == 0 ){
        BIMHandleHideWindow( inSessionHandle );
    }
    
    return handled;
}

// Mj[̃Cxgnh
static pascal OSStatus BIMPencilMenuEventHandler( EventHandlerCallRef inEventHandlerCallRef,
						  EventRef inEventRef, void *inUserData )
{
    OSStatus result;
    HICommand command;

    result = GetEventParameter( inEventRef, kEventParamDirectObject, typeHICommand, nil,
                               sizeof( command ), nil, &command);
    if( result == noErr )
	{
		switch( command.commandID )
		{
			case kAboutSKKMenuCommand:
				ServerConnectionFactory::sharedFactory().newConnection().send(kSKKShowAboutBox);
				break;
			
			case kPreferencesMenuCommand:
				ServerConnectionFactory::sharedFactory().newConnection().send(kSKKShowPreferencesBox);
				break;
                
			case kRegisterWordMenuCommand:
				ServerConnectionFactory::sharedFactory().newConnection().send(kSKKShowWordRegistrationBox);
				break;
            
            default:
                result = eventNotHandledErr;
                break;
        }
    }
    else
	{
        result = eventNotHandledErr;
    }
	return result;
}

/*void setSkkEggLikeNewline( Boolean skkEggLikeNewline )
{
    isSkkEggLikeNewline = skkEggLikeNewline;
}*/
