/*
	$Id: BIM.h,v 1.9 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include "CppCFString.h"

enum {
	kHiraganaIconIndex = 0,
	kZenKataIconIndex,
	kHanKataIconIndex,
	kZenAscIconIndex,
	kHanAscIconIndex,
	k_ICON_INDEX_END_
};

struct BIMSessionRecord {
    ComponentInstance	fComponentInstance;
	long		fLastUpdate;
    long		fLastUpdateLength;
    UniCharCount	fInputBufferCount;
    UniCharPtr		fInputBuffer;
	
	bool terminate_disabled; // ꂪtrueɂȂĂԂ́AterminateɂȂB
	class IMSessionInputMode* imsession_input_mode;
};

typedef struct BIMSessionRecord BIMSessionRecord;
typedef BIMSessionRecord *BIMSessionPtr;
typedef BIMSessionPtr *BIMSessionHandle;

ComponentResult BIMInitialize( ComponentInstance inComponentInstance,
                               MenuRef *outTextServiceMenu );
void BIMTerminate( ComponentInstance inComponentInstance );


ComponentResult	BIMSessionOpen( ComponentInstance inComponentInstance, 
                                BIMSessionHandle *outSessionHandle );
void BIMSessionClose( BIMSessionHandle sessionHandle );
ComponentResult	BIMSessionActivate( BIMSessionHandle sessionHandle );
ComponentResult	BIMSessionDeactivate( BIMSessionHandle sessionHandle );
ComponentResult	BIMSessionEvent( BIMSessionHandle sessionHandle, EventRef eventRef );
ComponentResult BIMSessionFix( BIMSessionHandle sessionHandle );
ComponentResult	BIMSessionHidePalettes( BIMSessionHandle sessionHandle );

void setSkkEggLikeNewline( Boolean skkEggLikeNewline );

BIMSessionHandle BIMGetActiveSession( void );
Boolean BIMHandleInput( BIMSessionHandle inSessionHandle, unsigned char inCharCode );

void BIMSetPencilMenuIcon(int menu_icon_index);

