/*
	$Id: BIMComponent.cpp,v 1.4 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#define TARGET_API_MAC_CARBON 1

#include <Carbon/Carbon.h>

#include "BIM.h"
#include "BIMComponent.h"
#include "BIMScript.h"

extern "C" pascal ComponentResult BIMComponentDispatch( ComponentParameters *inParams, Handle inSessionHandle );

long		gInstanceRefCount = 0;
MenuRef		gTextServiceMenu = nil;

static ComponentResult CallBIMFunction( ComponentParameters *inParams, ProcPtr inProcPtr,
                                        SInt32 inProcInfo );
static ComponentResult CallBIMFunctionWithStorage( Handle inStorage,
                                                   ComponentParameters *inParams,
                                                   ProcPtr inProcPtr, SInt32 inProcInfo );

// R|[lg̃Gg|CgBextern "C"ׂǂ͒肩łȂAꉞĂB
extern "C" pascal ComponentResult BIMComponentDispatch( ComponentParameters *inParams, Handle inSessionHandle)
{
    ComponentResult result;

    result = noErr;

    switch (inParams->what)
	{
		// Component Manager̎w
        case kComponentOpenSelect:
            result = CallBIMFunction( inParams, (ProcPtr) BIMOpenComponent,
                                      uppOpenComponentProcInfo );
            break;

        case kComponentCloseSelect:
            result = CallBIMFunctionWithStorage( inSessionHandle, inParams,
                                                 (ProcPtr) BIMCloseComponent,
                                                 uppCloseComponentProcInfo );
            break;

        case kComponentCanDoSelect:            
            result = CallBIMFunction( inParams, (ProcPtr) BIMCanDo, uppCanDoProcInfo );
            break;

        case kComponentVersionSelect:
            result = CallBIMFunction( inParams, (ProcPtr) BIMGetVersion, uppGetVersionProcInfo );
            break;
		
		// TSM̎w
        case kCMGetScriptLangSupport:
            result = CallBIMFunctionWithStorage( inSessionHandle, inParams,
                                                 (ProcPtr) BIMGetScriptLangSupport,
                                                 uppGetScriptLangSupportProcInfo );
            break;

        case kCMInitiateTextService:
            result = CallBIMFunctionWithStorage( inSessionHandle, inParams,
                                                 (ProcPtr) BIMInitiateTextService,
                                                 uppInitiateTextServiceProcInfo );
            break;

        case kCMTerminateTextService:
            result = CallBIMFunctionWithStorage( inSessionHandle, inParams,
                                                 (ProcPtr) BIMTerminateTextService,
                                                 uppTerminateTextServiceProcInfo );
            break;

        case kCMActivateTextService:
            result = CallBIMFunctionWithStorage( inSessionHandle, inParams,
                                                 (ProcPtr) BIMActivateTextService,
                                                 uppActivateTextServiceProcInfo );
            break;

        case kCMDeactivateTextService:
            result = CallBIMFunctionWithStorage( inSessionHandle, inParams,
                                                 (ProcPtr) BIMDeactivateTextService,
                                                 uppDeactivateTextServiceProcInfo );
            break;

        case kCMTextServiceEvent:
            result = CallBIMFunctionWithStorage( inSessionHandle, inParams,
                                                 (ProcPtr) BIMTextServiceEventRef,
                                                 uppTextServiceEventRefProcInfo );
            break;

        case kCMGetTextServiceMenu:
            result = CallBIMFunctionWithStorage( inSessionHandle, inParams,
                                                 (ProcPtr) BIMGetTextServiceMenu,
                                                 uppGetTextServiceMenuProcInfo );
            break;

        case kCMFixTextService:
            result = CallBIMFunctionWithStorage( inSessionHandle, inParams,
                                                 (ProcPtr) BIMFixTextService,
                                                 uppFixTextServiceProcInfo );
            break;

        case kCMHidePaletteWindows:
            result = CallBIMFunctionWithStorage( inSessionHandle, inParams,
                                                 (ProcPtr) BIMHidePaletteWindows,
                                                 uppHidePaletteWindowsProcInfo );
            break;

        default:
            result = badComponentSelector;
            break;
    }

    return result;
}

// R|[lg̋N
pascal ComponentResult BIMOpenComponent( ComponentInstance inComponentInstance )
{
    ComponentResult result;
    Handle sessionHandle;

    result = noErr;
    sessionHandle = nil;
	
	// ŏ̃CX^XO[olB
    if( gInstanceRefCount == 0 )
        result = BIMInitialize( inComponentInstance, &gTextServiceMenu );
    gInstanceRefCount++;

	
    if( result == noErr )
	{
		// Component StorageAo^B
        sessionHandle = GetComponentInstanceStorage( inComponentInstance );
        result = BIMSessionOpen( inComponentInstance, (BIMSessionHandle *) &sessionHandle );
        if( result == noErr )
            SetComponentInstanceStorage( inComponentInstance, sessionHandle );
    }

    return result;
}

// R|[lg̏I
pascal ComponentResult BIMCloseComponent( Handle inSessionHandle,
                                          ComponentInstance inComponentInstance )
{
    ComponentResult result = noErr;

    if( inComponentInstance == nil )
	{
        result = paramErr;
	}
    else
	{
        BIMSessionClose( (BIMSessionHandle) inSessionHandle );
        SetComponentInstanceStorage( inComponentInstance, nil );
    
       	// ꂪŌ̃CX^XO[öj
		gInstanceRefCount--;
        if( gInstanceRefCount == 0 )
            BIMTerminate( inComponentInstance );
    }
    return result;
}

// ZN^p\ǂԂB
pascal ComponentResult BIMCanDo( SInt16 inSelector )
{
    Boolean result;

    switch( inSelector )
	{
        case kComponentOpenSelect:
        case kComponentCloseSelect:
        case kComponentCanDoSelect:
        case kComponentVersionSelect:
            result = true;
            break;

        case kCMGetScriptLangSupport:
        case kCMInitiateTextService:
        case kCMTerminateTextService:
        case kCMActivateTextService:
        case kCMDeactivateTextService:
        case kCMTextServiceEvent:
        case kCMGetTextServiceMenu:
        case kCMFixTextService:
        case kCMHidePaletteWindows:
            result = true;
            break;

        default:
            result = false;
            break;
    }
    return result;
}

// ݁Å֐Ă΂邱Ƃ͂ȂB
pascal ComponentResult BIMGetVersion( void )
{
    return 0x00010000;
}

// ̎ނԂB
pascal ComponentResult BIMGetScriptLangSupport( Handle inSessionHandle,
                                              ScriptLanguageSupportHandle *outScriptHandle )
{
#pragma unused (inSessionHandle)

    OSStatus			result = noErr;
    ScriptLanguageRecord	scriptLanguageRecord;
	
    if( *outScriptHandle == NULL ) {
        *outScriptHandle = (ScriptLanguageSupportHandle) NewHandle ( sizeof( SInt16 ) );
        if( *outScriptHandle == NULL )
            result = memFullErr;
    }
	
    if( result == noErr ) {
        SetHandleSize( (Handle) *outScriptHandle, sizeof( SInt16 ) );
        result = MemError();
        if( result == noErr )
            ( **outScriptHandle )->fScriptLanguageCount = 0;        
    }

    // UnicodegƂ錾B
    if( result == noErr ) {
        scriptLanguageRecord.fScript = kTextEncodingUnicodeDefault;
        scriptLanguageRecord.fLanguage = kBIMLanguage;
        result = PtrAndHand( &scriptLanguageRecord, (Handle) *outScriptHandle,
                             sizeof( ScriptLanguageRecord ) );
        if( result == noErr )
            (**outScriptHandle)->fScriptLanguageCount++;
    }
	
    if( result ){
        if( *outScriptHandle ) {
            DisposeHandle( (Handle) *outScriptHandle );
            *outScriptHandle = NULL;
        }
    }
    return result;
}

// ̊֐͌Ă΂Ȃc炵B
ComponentResult BIMInitiateTextService( Handle inSessionHandle )
{
#pragma unused (inSessionHandle)

    return noErr;
}

// ̊֐͌Ă΂ȂB
pascal ComponentResult BIMTerminateTextService( Handle inSessionHandle )
{
#pragma unused (inSessionHandle)

    return noErr;
}

// TextServiceANeBuɂȂB
pascal ComponentResult BIMActivateTextService( Handle inSessionHandle )
{
    return BIMSessionActivate( (BIMSessionHandle) inSessionHandle );
}

// TextServiceANeBułȂȂB
pascal ComponentResult BIMDeactivateTextService( Handle inSessionHandle )
{
    return BIMSessionDeactivate( (BIMSessionHandle) inSessionHandle );
}

// R|[lg̃Cxgnh
pascal ComponentResult BIMTextServiceEventRef( Handle inSessionHandle, EventRef inEventRef )
{
    return BIMSessionEvent( (BIMSessionHandle) inSessionHandle, inEventRef );
}

// Mj[ԂB
pascal ComponentResult BIMGetTextServiceMenu( Handle inSessionHandle, MenuHandle *outMenuHandle )
{
    *outMenuHandle = gTextServiceMenu;
    return noErr;
}

// m
pascal ComponentResult BIMFixTextService( Handle inSessionHandle )
{
    return BIMSessionFix( (BIMSessionHandle) inSessionHandle );
}

// pbgB
pascal ComponentResult BIMHidePaletteWindows( Handle inSessionHandle )
{
    return BIMSessionHidePalettes( (BIMSessionHandle) inSessionHandle );
}

// UPP쐬AĂԁB
// CarbonUPPĖ{ɕKv̂H
static ComponentResult CallBIMFunction( ComponentParameters *inParams, ProcPtr inProcPtr,
                                        SInt32 inProcInfo )
{
    ComponentResult		result;
    ComponentFunctionUPP	componentFunctionUPP;

    result = noErr;
    componentFunctionUPP = NewComponentFunctionUPP( inProcPtr, inProcInfo );
    result = CallComponentFunction( inParams, componentFunctionUPP );
    DisposeComponentFunctionUPP( componentFunctionUPP );
    return result;
}
static ComponentResult CallBIMFunctionWithStorage( Handle inStorage,
                                                   ComponentParameters *inParams,
                                                   ProcPtr inProcPtr, SInt32 inProcInfo )
{
    ComponentResult		result;
    ComponentFunctionUPP	componentFunctionUPP;

    result = noErr;
    componentFunctionUPP = NewComponentFunctionUPP( inProcPtr, inProcInfo );
    result = CallComponentFunctionWithStorage( inStorage, inParams, componentFunctionUPP );
    DisposeComponentFunctionUPP( componentFunctionUPP );
    return result;
}
