/*
	$Id: CandidatesManager.h,v 1.3 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#include <map>
#include "CppCFString.h"
#import "CandidatesWindowController.h"

class CandidatesManager
{
	protected:
		map<unsigned int,CandidatesWindowController*> cand_windows;
		
		CandidatesManager();
		virtual ~CandidatesManager();
	
	public:
		static CandidatesManager& sharedManager();
		
		virtual unsigned createAndShow(int qd_x,int qd_y,const CppCFString& candidates_string);
		virtual void windowNext(unsigned int window_id);
		virtual void windowPrev(unsigned int window_id);
		virtual void closeWindow(unsigned int window_id);
		virtual CandidatesWindowController* getWindowController(unsigned window_id);
};
