/*
	$Id: CandidatesManager.mm,v 1.5 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import "CandidatesManager.h"
#include <vector>

static CandidatesManager* _shared_instance = NULL;

CandidatesManager& CandidatesManager::sharedManager()
{
	if (_shared_instance == NULL)
	{
		_shared_instance = new CandidatesManager();
	}
	return *_shared_instance;
}

CandidatesManager::CandidatesManager()
{

}

CandidatesManager::~CandidatesManager()
{
	
}

unsigned CandidatesManager::createAndShow(int qd_x,int qd_y,const CppCFString& candidates_string)
{
	// NSArray̌⃊Xg쐬B
	vector<CppCFString> cands_vec = candidates_string.split(' ');
	NSMutableArray* cands_array = [[NSMutableArray alloc] init];
	for (vector<CppCFString>::const_iterator ite = cands_vec.begin();ite != cands_vec.end();ite++)
	{
		UniChar* unistr = ite->toUniCharPtr();
		
		NSString* cand = [NSString stringWithCharacters:unistr length:ite->length()];
		[cands_array addObject:cand];
		
		delete unistr;
	}
	
	// gpID
	unsigned int window_id = 0;
	for (unsigned int i = 0;;i++)
	{
		if (cand_windows[i] == NULL)
		{
			window_id = i;
			break;
		}
	}
	
	// QuickDrawWCoreGraphicsW֕ϊB
	NSSize mainscreen_size = [[NSScreen mainScreen] frame].size;
	float cg_x = qd_x;
	float cg_y = mainscreen_size.height - qd_y;
	
	// CWC쐬A
	CandidatesWindowController* cwc = [[CandidatesWindowController alloc] initWithCandidates:cands_array];
	NSSize cwc_size = [[cwc window] frame].size;
	
	// W߁A
	float window_x = cg_x;
	float window_y = cg_y - cwc_size.height;
	if (window_x < 0) window_x = 0;
	if (window_x + cwc_size.width > mainscreen_size.width)
		window_x = mainscreen_size.width - cwc_size.width;
	if (window_y < 0) window_y = 0;
	if (window_y + cwc_size.height > mainscreen_size.height)
		window_y = mainscreen_size.height - cwc_size.height;
	[[cwc window] setFrameOrigin:NSMakePoint(window_x,window_y)];
	
	// \B
	[cwc showWindow:nil];
	
	// CWCo^B
	cand_windows[window_id] = cwc;
	
	return window_id;
}

void CandidatesManager::windowNext(unsigned int window_id)
{
	[cand_windows[window_id] showNextFrame];
}

void CandidatesManager::windowPrev(unsigned int window_id)
{
	[cand_windows[window_id] showPrevFrame];
}

void CandidatesManager::closeWindow(unsigned int window_id)
{
	CandidatesWindowController* cwc = cand_windows[window_id];
	[[cwc window] orderOut:nil];
	[cwc release];
	
	cand_windows[window_id] = NULL;
}

CandidatesWindowController* CandidatesManager::getWindowController(unsigned window_id)
{
	return cand_windows[window_id];
}