/*
	$Id: CandidatesView.mm,v 1.5 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import "CandidatesView.h"
#import "CandidatesWindowController.h"

@implementation CandidatesView

- initWithCandidates:(NSArray*)cands
{
	self = [super initWithFrame:NSMakeRect(0,0,100,100)]; // TCY͂̎_ł͂܂oȂB
	
	candidates = [cands retain];
	font = [NSFont systemFontOfSize:12.0];
	cands_per_frame = 7;
	
	// ڂ̉ƏcZoB
	unichar tempunistr[] = {'A',':',' ',0x5996};
	NSMutableAttributedString* tempstr = [[NSMutableAttributedString alloc] initWithString:
									[NSString stringWithCharacters:tempunistr length:4]];
	[tempstr addAttribute:NSFontAttributeName value:font range:NSMakeRange(0,4)];
	NSSize tempsize = [tempstr size];
	item_width = tempsize.width;
	item_height = tempsize.height;
	[tempstr release];
	
	// [cn]\̉ZoB
	unichar remainingunistr[] = {'[',0x6b8b,0x308a,'0','0','0',']'};
	NSMutableAttributedString* remainingstr = [[NSMutableAttributedString alloc] initWithString:
								[NSString stringWithCharacters:remainingunistr length:7]];
	[remainingstr addAttribute:NSFontAttributeName value:font range:NSMakeRange(0,7)];
	remaining_width = [remainingstr size].width;
	[remainingstr release];
	
	// ]ȂǂvZ/ݒ
	margin_x = margin_y = 10;
	interval_x = 20;
	interval_y = margin_y * 2;
	
	// t[Zo
	int n_candidates = [candidates count];
	n_frames = ((n_candidates - ((n_candidates - 1) % cands_per_frame)) / cands_per_frame) + 1;
	current_frame = 0;
	offset = 0;
	
	// ŏIIɃEChẼTCY肷BItXN[nilB
	offscreen_width = margin_x * 2  +  item_width * cands_per_frame  +  interval_x * cands_per_frame  +  remaining_width;
	offscreen_height = margin_y * 2  +  item_height * n_frames  +  interval_y * (n_frames - 1);
	offscreen = nil;
	[self setFrame:NSMakeRect(0,0,offscreen_width,item_height + interval_y)];
	
	frames_rendered = 0;
	return self;
}

- (void)drawRect:(NSRect)rect
{
    if (offscreen == nil)
	{
		offscreen = [[NSImage alloc] initWithSize:NSMakeSize(offscreen_width,offscreen_height)];
		/*[offscreen lockFocus];
			
			char labels[] = {'A','S','D','F','J','K','L'};
			NSRange four_chars = NSMakeRange(0,4);
			
			unichar remaining_unistr_format[] = {'[',0x6b8b,0x308a,'%','d',']'};
			NSString* remaining_format = [NSString stringWithCharacters:remaining_unistr_format length:6];
			
			const int n_candidates = [candidates count];
			for (unsigned i = 0;i < n_frames;i++)
			{
				// `
				for (unsigned j = 0;j < cands_per_frame;j++)
				{
					int cand_index = i*cands_per_frame + j;
					if (cand_index >= n_candidates) break;
					
					NSMutableAttributedString* cand_astr =
						[[NSMutableAttributedString alloc] initWithString:
							[NSString stringWithFormat:@"%c: %@",
									labels[j],
									[candidates objectAtIndex:cand_index]]];
					[cand_astr addAttribute:NSFontAttributeName value:font range:four_chars];
					
					[cand_astr drawAtPoint:NSMakePoint(
							margin_x  +  item_width * j  +  interval_x * j,
							margin_y  +  item_height * i  +  interval_y * i)];
					
					[cand_astr release];
				}
				
				// cn`
				int remaining = n_candidates - (i+1) * cands_per_frame;
				if (remaining < 0) remaining = 0;
				NSMutableAttributedString* remaining_astr =
					[[NSMutableAttributedString alloc] initWithString:
							[NSString stringWithFormat:remaining_format,remaining]];
				[remaining_astr addAttribute:NSFontAttributeName
								value:font
								range:NSMakeRange(0,[remaining_astr length])];
				
				[remaining_astr drawAtPoint:NSMakePoint(
							margin_x  +  item_width * cands_per_frame  +  interval_x * cands_per_frame,
							margin_y  +  item_height * i  +  interval_y * i)];
				
				[remaining_astr release];
			}
			
		[offscreen unlockFocus];*/
	}
	
	if (current_frame >= frames_rendered) // ̎ɕ\ׂt[܂_OĂȂB
	{
		[offscreen lockFocus];
		
			char labels[] = {'A','S','D','F','J','K','L'};
			NSRange four_chars = NSMakeRange(0,4);
			
			unichar remaining_unistr_format[] = {'[',0x6b8b,0x308a,'%','d',']'};
			NSString* remaining_format = [NSString stringWithCharacters:remaining_unistr_format length:6];
		
			// `
			const int n_candidates = [candidates count];
			for (unsigned i = 0;i < cands_per_frame;i++)
			{
				int cand_index = current_frame*cands_per_frame + i;
				if (cand_index >= n_candidates) break;
				
				NSMutableAttributedString* cand_astr =
					[[NSMutableAttributedString alloc] initWithString:
						[NSString stringWithFormat:@"%c: %@",
								labels[i],
								[candidates objectAtIndex:cand_index]]];
				[cand_astr addAttribute:NSFontAttributeName value:font range:four_chars];
				
				[cand_astr drawAtPoint:NSMakePoint(
						margin_x  +  item_width * i  +  interval_x * i,
						margin_y  +  item_height * current_frame  +  interval_y * current_frame)];
				
				[cand_astr release];
			}
			
			// cn`
			int remaining = n_candidates - (current_frame+1) * cands_per_frame;
			if (remaining < 0) remaining = 0;
			NSMutableAttributedString* remaining_astr =
				[[NSMutableAttributedString alloc] initWithString:
						[NSString stringWithFormat:remaining_format,remaining]];
			[remaining_astr addAttribute:NSFontAttributeName
							value:font
							range:NSMakeRange(0,[remaining_astr length])];
			
			[remaining_astr drawAtPoint:NSMakePoint(
						margin_x  +  item_width * cands_per_frame  +  interval_x * cands_per_frame,
						margin_y  +  item_height * current_frame  +  interval_y * current_frame)];
			
			[remaining_astr release];
		
		[offscreen unlockFocus];
		frames_rendered = current_frame + 1;
	}
	
	[offscreen drawInRect:NSMakeRect(0,0,offscreen_width,offscreen_height)
				 fromRect:NSMakeRect(0,current_frame * (interval_y + item_height) + offset,offscreen_width,offscreen_height)
				operation:NSCompositeSourceOver
				 fraction:1.0];
}

- (void)dealloc
{
	[candidates release];
	[font release];
	[offscreen release];
	[super dealloc];
}

- (void)showNextFrame
{
	current_frame++;
	[self display];
}

- (void)showPrevFrame
{
	current_frame--;
	[self display];
}

- (unsigned)getCandidatesPerFrame
{
	return cands_per_frame;
}

- (unsigned)getNumOfFrames
{
	return n_frames;
}

@end
