/*
	$Id: CharacterTranslator.h,v 1.2 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <string>
#include <vector>
#include <utility>
#include <iostream>
#include "CppCFString.h"
using namespace std;

class CharacterTranslator
{
	protected:
		vector<vector<pair<CppCFString,CppCFString> > > table_root;
		/*
			iڂvectoŕAϊ̕zvfԍƂB
			Ⴆ΁uJ,@vƂ`΁A"J"3Ȃ̂ł̒`3Ԗڂ̗vfɓB
			
			iڂvectoŕApair𑩂˂B̎A܂܂pairfirst͑̕SēłB
			Ⴆ΁u,AvƁu,Jv͓vectorɓ邪AvectorɁuJ,@v͊܂܂ȂB
			
			pair͕ϊOƕϊ\BႦΒ`u,Av̏ꍇ́Afirst""Asecond"A"B
		*/
		
		virtual void load(istream& is);
		
	public:
		CharacterTranslator(const string& table_name); // translation-to-hiragana 
		virtual ~CharacterTranslator();
		
		CppCFString translate(const CppCFString& src);
};