/*
	$Id: CppMessagePortServer.cpp,v 1.3 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CppMessagePortServer.h"

CppMessagePortServer::CppMessagePortServer(const CppCFString& port_name,CFRunLoopRef runloop_to_install) throw(std::exception)
{	
	// T[o[̍쐬Ɏsexception𓊂B
	CFMessagePortContext context;
	context.version = 0;
	context.info = this;
	context.retain = NULL;
	context.release = NULL;
	context.copyDescription = NULL;
	
	CFMessagePortRef port = CFMessagePortCreateLocal(
				NULL,
				port_name.getString(),
				&CppMessagePortServer::callback_message_received,
				&context,
				NULL);
	if (port == NULL)
	{
		throw std::exception();
	}
	
	runloop = runloop_to_install;
	runloop_source = CFMessagePortCreateRunLoopSource(NULL,port,0);
	
	CFRunLoopAddSource(runloop,runloop_source,kCFRunLoopCommonModes);
	
	CFRelease(port);
}

CppMessagePortServer::~CppMessagePortServer()
{
	CFRunLoopRemoveSource(runloop,runloop_source,kCFRunLoopCommonModes);
	CFRelease(runloop_source);
}

CFDataRef CppMessagePortServer::callback_message_received(CFMessagePortRef server_port,SInt32 message_id,
														  CFDataRef attachment,void *context_info)
{
	CppMessagePortServer* self = reinterpret_cast<CppMessagePortServer*>(context_info);
	
	CppCFData attachment_data(attachment);
	return self->messageReceived(message_id,attachment_data).getCloneOfData();
}