/*
 *  CppScrap.cpp
 *  AquaSKK
 *
 *  Created by [admin] on Wed May 14 2003.
 *  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
 *
 */

#include "CppScrap.h"

// ---------- CppScrap ---------- //

CppScrap::CppScrap() {
	GetCurrentScrap(&scrap);
}

CppScrap::CppScrap(const CppScrap& copy_src) {
	scrap = copy_src.scrap;
}

CppScrapFlavor * CppScrap::makeFlavor(ScrapFlavorType type) {
	return new CppScrapFlavor(*this,type);
}

ScrapRef CppScrap::getScrapRef() const {
	return scrap;
}

// ---------- CppScrapFlavor ---------- //

CppScrapFlavor::CppScrapFlavor(CppScrap& s,ScrapFlavorType t)
	:scrap(s),
	 type(t) {
	
}

bool CppScrapFlavor::exists() const {
	// このflavorのデータが存在するか？
	ScrapFlavorFlags flags;
	return GetScrapFlavorFlags(scrap.getScrapRef(),type,&flags) != scrapFlavorNotFoundErr;
}

unsigned CppScrapFlavor::size() const {
	if (exists()) {
		Size size;
		GetScrapFlavorSize(scrap.getScrapRef(),type,&size);
		return size;
	}
	else {
		return 0;
	}
}

CppCFData CppScrapFlavor::content() const throw(std::exception) {
	if (exists()) {
		Size size = this->size();
		char* buf = new char[size];
		GetScrapFlavorData(scrap.getScrapRef(),type,&size,buf);
		CppCFData data(buf,size);
		delete[] buf;
		
		return data;
	}
	else {
		throw std::exception();
	}
}
