/*
	$Id: CppScrap.h,v 1.2 2003/10/30 02:26:09 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include <exception>
#include "CppCFData.h"

/*
	ScrapRefのラッパーであるCppScrapの他、
	scrap flavorを表すCppScrapFlavorを定義します。
*/

class CppScrap;
class CppScrapFlavor;

class CppScrap {
	protected:
		ScrapRef scrap; // クリアされると無効になる事に注意。
	
	public:
		CppScrap(); // 通常のクリップボードを表すCppScrapを作る。
		CppScrap(const CppScrap& copy_src); // コピーコンストラクタは、同じScrapRefを指すものを作る。
		
		CppScrapFlavor* makeFlavor(ScrapFlavorType type);
		ScrapRef getScrapRef() const;
};

class CppScrapFlavor {
	protected:
		CppScrap scrap;
		ScrapFlavorType type;
	
	public:
		CppScrapFlavor(CppScrap& s,ScrapFlavorType t);
		
		bool exists() const; // このflavorが存在するか？
		unsigned size() const; // flavorのサイズ。存在しなければ0。
		CppCFData content() const throw(std::exception); // 中身。存在しなければ例外を投げる。
};