/*
	$Id: DMDictionary.h,v 1.3 2002/11/29 12:23:12 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
    Directory ManegerΉ@2002.09.25 Shin_ichi Abe.
*/
#pragma once
#include <string>
#include <iostream>
#include <map>
#include <vector>
#include "CppCFString.h"
#include "Dictionary.h"
using namespace std;

class DMDictionary : public Dictionary 
{
	protected:
		DCMDictionaryID dicID[10];
        DCMDictionaryRef dicRef[10];
        int numID, numRef;
		
	public:
        DMDictionary(const vector<CppCFString>& kotoeri_dic_file);
		virtual ~DMDictionary();
		
		vector<CppCFString> findWithoutOkuri(const CppCFString& query);
		vector<OkuriganaEntry> findWithOkuri(const CppCFString& root);
		
		vector<CppCFString> findCompletions(const CppCFString& query);
		
		virtual void registerWord(const CppCFString& index,const CppCFString& okuri,const CppCFString& kanji);
		virtual void registerWord(const CppCFString& index,const CppCFString& kanji);
		virtual void removeWord(const CppCFString& index,const CppCFString& okuri,const CppCFString& kanji);
		virtual void removeWord(const CppCFString& index,const CppCFString& kanji);
		
		virtual void changeDictionaryFile(const vector<CppCFString>& kotoeri_dic_file);
		
		virtual void save(bool& terminate_flag); // TuXbhĂԂƁB
        
        bool DMDictionary::checkDictionary( const CFStringRef fpath );
        void closeDictionary();	//B
		
    private:
        void openDictionary( const CppCFString& fpath );
        
        vector<CppCFString> DMDictionary::findRecord( const CppCFString& query );
};


OSErr FilePathToFSSpec( CFStringRef filePath, FSSpec *apSpec );