/*
	$Id: Dictionary.h,v 1.2 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <string>
#include <vector>
#include "CppCFString.h"
#include "OkuriganaEntry.h"
using namespace std;

/*
	AquaSKKServeȑo鎫\ۃNXłB
	SKKDictionaryDMDictionary͂̃NXp܂B
*/
class Dictionary
{
	public:
		virtual vector<CppCFString> findWithoutOkuri(const CppCFString& query) = 0;
		virtual vector<OkuriganaEntry> findWithOkuri(const CppCFString& root) = 0;
		
		virtual vector<CppCFString> findCompletions(const CppCFString& query) = 0;
		
		virtual void registerWord(const CppCFString& index,const CppCFString& okuri,const CppCFString& kanji) = 0;
		virtual void registerWord(const CppCFString& index,const CppCFString& kanji) = 0;
		virtual void removeWord(const CppCFString& index,const CppCFString& okuri,const CppCFString& kanji) = 0;
		virtual void removeWord(const CppCFString& index,const CppCFString& kanji) = 0;
		
		virtual void save(bool& terminate_flag) = 0;
};
