/*  -*- objc -*-
    $Id: Foundation.mm,v 1.15 2003/06/22 10:56:40 phonohawk Exp $
    ---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import "Foundation.h"
#import "CandidatesWindowController.h"
#import "UserDicSaver.h"
#import "PreferencesController.h"
#include <time.h>
#include <signal.h>
#include "SKKServer.h"
#include "ServerMessageReceiver.h"
#include "Skkserv.h"

static Foundation* _shared_instance = NULL;

void installSignalHandler(void);
void sigHandlerTerminate(int sigaction_arg);

@implementation Foundation

- (void)awakeFromNib
{
	_shared_instance = self;
}

+ (Foundation*)sharedFoundation
{
	return _shared_instance;
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
  // VOinhCXg[
  installSignalHandler();
	
  // sǂށBp[X͂܂ȂB
  printf("SKKServer started loading dictionary...\n");
  time_t start_time = time(NULL);
	
  [NSColor setIgnoresAlpha:NO];
  
  PreferencesController* pref = [PreferencesController sharedController];
  
  vector<CppCFString> vec;
  
  for(unsigned i = 0 ; i < [[pref path] count] ; i++ ) {
    vec.push_back((CFStringRef)[[pref path] objectAtIndex:i]);
  }
  
  SKKServer::sharedServer([[pref getPathToMainDic] cString],
			  [[pref getPathToSubDic] cString],
			  [[pref getPathToUserDic] cString],
			  vec);
  
  printf("finished loading dictionary. %ld seconds elapsed.\n",time(NULL) - start_time);
  
  // [U[ۑXbhNB̃Xbh̓AvP[VI܂œB
  [[UserDicSaver sharedSaver] start];
  
  // INB
  ServerMessageReceiver::start([[NSRunLoop currentRunLoop] getCFRunLoop]);

  // KvȂskkservG~INB
  if ([pref isSkkservEnabled]) {
    Skkserv::sharedServer().start([pref skkservPort]);
  }
}

- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender
{
	// [U[ۑB
	[[UserDicSaver sharedSaver] saveNow];
	[[UserDicSaver sharedSaver] waitUntilSaverFinishes];
	
    //Ƃ莫N[Y
    SKKServer::sharedServer().getKotoeriDic().closeDictionary();
    
	return NSTerminateNow;
}

@end

void installSignalHandler(void)
{
	// SIGINT SIGHUP SIGTERMsigHandlerTerminate蓖ĂB
	struct sigaction signal_action;
	signal_action.sa_handler = sigHandlerTerminate;
	signal_action.sa_flags = 0;
	sigemptyset(&signal_action.sa_mask);
	
	sigaction(SIGINT,&signal_action,NULL);
	sigaction(SIGHUP,&signal_action,NULL);
	sigaction(SIGTERM,&signal_action,NULL);
}

void sigHandlerTerminate(int sigaction_arg)
{
	[[NSApplication sharedApplication] terminate:NULL];
}
