/*
	$Id: HanAscInputMode.cpp,v 1.7 2002/12/19 13:37:37 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "HanAscInputMode.h"
#include "ParentInputMode.h"
#include "SkkConfig.h"

HanAscInputMode::HanAscInputMode(class ParentInputMode& parent)
	:ChildInputMode(parent)
{

}

bool HanAscInputMode::handleInput(unsigned char inputChar)
{
	if (SkkConfig::config().isKakuteiKey(inputChar))
	{
		// ̓[hցB
		parent->goHiraganaInputMode();
		return false;
	}
	else if (SkkConfig::config().isCancelKey(inputChar))
	{
		// do nothing
		return false;
	}
	else
	{
		buffer += inputChar;
		return true;
	}
}

bool HanAscInputMode::handleBackSpace()
{
	return false;
}

bool HanAscInputMode::handleReturn()
{
	return false;
}

bool HanAscInputMode::handleArrow(int kind)
{
	return false;
}

CppCFString HanAscInputMode::getStringToDisplay()
{
	return buffer;
}

CppCFString HanAscInputMode::getStringToFix()
{
	if (buffer.length() == 0)
	{
		return buffer;
	}
	else
	{
		CppCFString result = buffer;
		buffer.clear();
		return result;
	}
}
