/*
	$Id: HanKataInputMode.h,v 1.11 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once

#include <Carbon/Carbon.h>
#include "CppCFString.h"
#include "BIM.h"
#include "InputMode.h"
#include "ChildInputMode.h"
#include "CharacterTranslator.h"

class HanKataInputMode : public ChildInputMode
{
	public:
		HanKataInputMode(class ParentInputMode& parent);
		virtual ~HanKataInputMode() {}
		
		virtual bool handleInput(unsigned char inputChar);
		virtual bool handleBackSpace();
		virtual bool handleReturn();
		virtual bool handleArrow(int kind);
		virtual bool handleCg();
		virtual void terminate();
		virtual bool isQueueEmpty() const;
		virtual CppCFString getStringToDisplay();
		virtual CppCFString getStringToFix();
		
		static CppCFString convert(const CppCFString& from); // 𔼊pЉɕϊ
        
	protected:
		CppCFString buffer;
		CppCFString str_to_fix;
		
		static CharacterTranslator translator;
};
