/*
	$Id: IMSessionInputMode.cpp,v 1.8 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <string.h>
#include "BIM.h"
#include "BIMInputEvents.h"
#include "IMSessionInputMode.h"



IMSessionInputMode::IMSessionInputMode(BIMSessionHandle session_handle)
	:ParentInputMode(),
	 session_handle(session_handle)
{

}

void IMSessionInputMode::terminate()
{
	ParentInputMode::terminate();
	
	(*session_handle)->fInputBufferCount = 0; // obt@͋ɂĂB
}

void IMSessionInputMode::fix(const CppCFString& str_to_fix)
{
	copyStringToBuffer(str_to_fix);
	
	if( ( *session_handle )->fInputBufferCount )
	{
		(*session_handle)->terminate_disabled = true;
		
        BIMUpdateActiveInputArea(session_handle,TRUE);
        (*session_handle)->fLastUpdateLength = 0;
        (*session_handle)->fInputBufferCount = 0;
		
		(*session_handle)->terminate_disabled = false;
    }
}

void IMSessionInputMode::display(const CppCFString& str_to_display)
{
	//printf("IMSessionInputMode::display called. (len = %d)\n",str_to_display.length());
	copyStringToBuffer(str_to_display);
	BIMUpdateActiveInputArea(session_handle,FALSE);
}

void IMSessionInputMode::copyStringToBuffer(const CppCFString& str)
{
	// fInputBufferstrRs[B
	UniChar* unistr = str.toUniCharPtr();
	
	bcopy(unistr,(*session_handle)->fInputBuffer,str.length() * sizeof(UniChar));
	(*session_handle)->fInputBufferCount = str.length();
	
	delete unistr;
}