/*
	$Id: KanaTreeController.h,v 1.2 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <Carbon/Carbon.h>
#include <string>
#include "KanaTreeElement.h"
using namespace std;

class KanaTreeController
{
	protected:
		KanaTreeElement root;
		
		virtual void load(istream& is);
		
		// L[̏I܂ōsĂmoȂꍇReachedEndOfQueueException𓊂B
		virtual KanaTreeElement& trace(CppCFString& queue,KanaTreeElement& parent,unsigned level = 0);
	
	public:
		static const int OUTPUT_HIRAGANA = 0;
		static const int OUTPUT_ZENKATA = 1;
		static const int OUTPUT_HANKATA = 2;
		static KanaTreeController& defaultTreeController();
		
		KanaTreeController(const string& fpath); // [t@Cւ̃pX
		virtual ~KanaTreeController();
		
		virtual CppCFString trace(int output_type,CppCFString& queue);
};

class ReachedEndOfQueueException : public exception {};