/*
	$Id: KanaTreeElement.h,v 1.3 2002/11/29 12:29:10 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include <vector>
#include <exception>
#include "CppCFString.h"
using namespace std;

class KanaTreeElement
{
	protected:
		CppCFString content_hiragana,content_zenkata,content_hankata; // ̗vf\B΋B
		UniChar label; // ̗vf̃x
		UniChar next_state; // ԁB0x00B
		
		vector<KanaTreeElement> childs; // SĂ̎q
	
	public:
		KanaTreeElement(const CppCFString& content_hiragana,
						const CppCFString& content_zenkata,
						const CppCFString& content_hankata,
						const UniChar label,
						const UniChar next_state = 0x00);
		KanaTreeElement(const KanaTreeElement& copy_source);
		virtual ~KanaTreeElement();
		
		virtual KanaTreeElement& addChild(const KanaTreeElement& child); // gԂB
		
		//H镪򂪖ChildNotFoundException𓊂B
		virtual KanaTreeElement& trace(UniChar label);
		
		virtual const CppCFString& getContentAsHiragana() const;
		virtual const CppCFString& getContentAsZenKata() const;
		virtual const CppCFString& getContentAsHanKata() const;
		virtual UniChar getLabel() const;
		virtual UniChar getNextState() const;
		virtual bool hasAnyChilds() const;
		virtual const vector<KanaTreeElement>& getChilds() const;
};

class ChildNotFoundException : public exception {};