/*
	$Id: KanjiConversionMode.h,v 1.16 2003/05/14 12:03:14 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once

#include <Carbon/Carbon.h>
#include <vector>
#include "CppCFString.h"
#include "BIM.h"
#include "InputMode.h"
#include "ChildInputMode.h"
#include "CppCFData.h"
#include "RegistrationStarter.h"
using namespace std;

class KanjiConversionMode : public ChildInputMode , public RegistrationStarter
{
	protected:
		static const int STATUS_NULL = 0; // ϊ[hɂȂĂȂԁB擪ɁB
		static const int STATUS_WHITE_ROOT = 1; // [hŁA艼O
		static const int STATUS_WHITE_OKURI = 2; // [hŁA艼ꂽ
		static const int STATUS_BLACK = 3; // [h
		static const int STATUS_BLACK_WITH_WINDOW = 4; // [hŁAIEChEJĂB
		static const int STATUS_PROMPT = 5; // vvgoĂB
		
		class WordRegisterMode* word_register_mode; // NULLłȂ͒Po^[hNB
		
		int status;
		CppCFString root; // 艼̖BFuvȂuv
		CppCFString okuri; // 艼̕BFuvȂuv
		UniChar okuri_head; // 艼̓̃At@xbgBFuvȂurv
		CppCFString root_to_display,okuri_to_display; // ʕ\pB͓r̃At@xbgȂǂB
		
		static const int PROMPT_DELETE_FROM_USER_DIC = 1; // [U[P폜
		int prompt_type; // vvg̎ށB
		CppCFString prompt; // vvg
		CppCFString prompt_input; // vvgɃ[U[͂
		
		vector<CppCFString> candidates; // SĂ̌
		unsigned current_candidate_index; // ݂̌ԍ
		
		unsigned show_cands_window_after_Nth_cand; // ڈȍ~̌IEChEɕ\邩B
		
		unsigned candidates_window_id; // statusSTATUS_BLACK_WITH_WINDOŴƂAIEChEIDB
		unsigned candidates_window_current_frame; // IEChĚ݂̃t[
		unsigned candidates_window_cands_per_frame; // IEChE1t[̌␔
		unsigned candidates_window_num_of_frames; // IEChẼt[
		
		bool completion_mode; // o⊮[hB̃[hł̓sIhƃJ}⊮̑ɎgB
		vector<CppCFString> completions; // ⊮̌
		unsigned current_completion_index; // ݂̕⊮̌ԍ
        
        bool henkanModeStatus;	//ݕϊԂɂȂĂ邩B
        
		virtual void startRegisteringWord();
		virtual void askServerTheCandidates(bool hasOkuri);
		virtual void askServerTheCompletions();
		virtual void makeServerRemoveWord();
		virtual void sendCurrentCandidateToServerToRegister();
		virtual void openCandidatesWindow();
		virtual void goToPrevCandidatesFrame();
		virtual void goToNextCandidatesFrame();
		virtual void closeCandidatesWindow();
		virtual void initialize();
		
	public:
		KanjiConversionMode(class ParentInputMode& parent);
		virtual ~KanjiConversionMode();
		
		virtual bool handleInput(unsigned char inputChar);
		virtual bool handleBackSpace();
		virtual bool handleReturn();
		virtual bool handleArrow(int kind);
		virtual bool handleCg();
		virtual bool handleCy();
		virtual bool handleTab();
		virtual void terminate();
		virtual CppCFString getStringToDisplay();
		virtual CppCFString getStringToFix();
		
		virtual void wordRegistrationFinished(); // WordRegisterModepB
		virtual void wordRegistrationCanceled(); // WordRegisterModepB
        
    private:
        bool handleInputChar(unsigned char inputChar);
};

void askServerTheCandidates(const CppCFData& query,vector<CppCFString>& candidates);
void addCandidate(const CppCFString& candidate,vector<CppCFString>& candidates);
void sendWordToServerToRegister(const CppCFString& index,const CppCFString& okuri,const CppCFString& kanji);
void sendWordToServerToRegister(const CppCFString& index,const CppCFString& kanji);
void askServerTheCompletions(const CppCFData& query,vector<CppCFString>& completions);
void makeServerRemoveWord(const CppCFData& query);
void openCandidatesWindow(const CppCFString& str_candidates,unsigned& window_id,unsigned& cands_per_frame,unsigned& num_of_frames);
CppCFData newCFDataRefWithWindowID(unsigned window_id);
