/*
	$Id: OkuriganaEntry.h,v 1.7 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <Carbon/Carbon.h>
#include <vector>
#include "CppCFString.h"

class OkuriganaEntry
{
	protected:
		CppCFString kana; // 艼̍ŏ̕Bur //[//]/ƂȂĂuvB󕶎񂪃ChJ[hB
		vector<CppCFString> kanji_candidates; // ̌B[///]ȂuҁvƁuv
		// CppCFString̔złȂUniChar̔złǂmȂAꕶɌȂꍇ邩mȂB
		
	public:
		OkuriganaEntry(); // ChJ[hBkanji_candidates͋B
		OkuriganaEntry(const CppCFString& okurigana); // kanji_candidates͋B
		OkuriganaEntry(const OkuriganaEntry& okurigana_entry); // Rs[RXgN^
		virtual ~OkuriganaEntry();
		
		virtual void add(const CppCFString& candidate);
		virtual void insert(const CppCFString& candidate,unsigned pos);
		virtual void remove(unsigned pos);
		virtual void removeRedundantItems();
		virtual const CppCFString& getKana() const;
		virtual bool isWild() const; // 艼ȂtrueԂB
		virtual void setKana(const CppCFString& new_kana);
		virtual const vector<CppCFString>& getCandidates() const;
		
		virtual unsigned size() const;
		virtual const CppCFString& operator [](unsigned n) const; // nԖڂ̗vfǂݏo
};