/*  -*- objc -*-
    $Id: PreferencesController.h,v 1.5 2003/06/22 10:56:40 phonohawk Exp $
    ---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import <Cocoa/Cocoa.h>

/*
  ̃NXSingletonłB
*/

@interface PreferencesController : NSWindowController {
  IBOutlet id skkEggLikeNewlineBtn;
  IBOutlet id winColor;
  IBOutlet id winTransparent;
    
  IBOutlet NSTextField *maindic_path;
  IBOutlet NSTextField *subdic_path;
    
  IBOutlet id addKotoeriBtn;
  IBOutlet id kotoeriDicTable;
  IBOutlet id removeKotoeriBtn;

  IBOutlet NSButton *skkserv_enabled;
  IBOutlet NSTextField *skkserv_port;
  IBOutlet NSButton *skkserv_local_only;
	
  NSString* path_to_main_dic;
  NSString* path_to_sub_dic;
    
  NSMutableArray *dicPath;
}
+ (PreferencesController*)sharedController;
- (NSString*)getPathToMainDic;
- (NSString*)getPathToSubDic;
- (NSString*)getPathToUserDic;

- init;

- (NSColor *)windowColor;
- (float)windowAlpha;
- (BOOL)isSkkEggLikeNewline;

- (NSArray *)path;

- (IBAction)skkEggLikeNewline:(id)sender;

- (IBAction)selectMainDic:(id)sender;
- (IBAction)selectSubDic:(id)sender;

- (IBAction)addKotoeriDic:(id)sender;
- (IBAction)removeKotoeriDic:(id)sender;
- (IBAction)saveUserDefault:(id)sender;
- (void)controlSetting;

- (BOOL)isSkkservEnabled;
- (int)skkservPort;
- (BOOL)isSkkservLocalOnly;

@end
