/*  -*- c++ -*-
    $Id: Skkserv.h,v 1.1 2003/06/22 10:56:40 phonohawk Exp $
    ---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include "net/Socket.h"
using namespace net;
using namespace std;

class Skkserv {
private:
    Socket* listening;
    bool local_only;
    bool flag_term;
    
    Skkserv();
    virtual ~Skkserv();
    
public:
    static Skkserv& sharedServer();
    virtual Skkserv& setLocalOnly(bool b);
    virtual Skkserv& start(int port);
    virtual Skkserv& stop();
    virtual bool isRunning() const;
    virtual int port() const;
    
    virtual void listening_thread_routine();
};

class SkkservSession {
private:
    Socket* sock;

public:
    SkkservSession(Socket* sock);
    virtual ~SkkservSession();
    
    virtual void run();
};
