/*
	$Id: UserDicSaver.mm,v 1.9 2002/11/29 12:23:11 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#import "UserDicSaver.h"
//#include <fstream>
//#include <stdio.h>
#include "SKKServer.h"
using namespace std;

@implementation UserDicSaver

+ (UserDicSaver*)sharedSaver
{
	static UserDicSaver* _shared_instance = NULL;
	if (_shared_instance == NULL)
	{
		_shared_instance = [[UserDicSaver alloc] init];
	}
	return _shared_instance;
}

- init
{
	self = [super init];
	
	interval_minutes = 10; // ftHgł10
	is_running = false;
	is_saving_now = false;
	is_dirty = false;
	flag_terminate_saving = false;
	
	return self;
}

- (void)dealloc
{
	[super dealloc];
}

- (void)start
{
	if (!is_running)
	{
		[NSApplication detachDrawingThread:@selector(triggerThread:)
								toTarget:self
								withObject:nil];
	}
}

- (void)triggerThread:(NSNull*)null_value
{
	while (true)
	{
		NSDate* time_after_interval = [[NSDate alloc] initWithTimeIntervalSinceNow:interval_minutes * 60];
		[NSThread sleepUntilDate:time_after_interval];
		[time_after_interval release];
		
		if (is_dirty)
		{
			if (is_saving_now)
			{
				// ۑA̕ۑĂe͌Â̂Œ~B
				[self terminateSaving];
			}
			
			[NSApplication detachDrawingThread:@selector(saverThread:)
									  toTarget:self
									withObject:nil];
		}
	}
}

- (void)saveNow
{
	if (!is_dirty) return;
	
	if (is_saving_now)
	{
		[self terminateSaving];
	}
	
	is_saving_now = true;
	[NSApplication detachDrawingThread:@selector(saverThread:)
							  toTarget:self
							withObject:nil];
}

- (void)waitUntilSaverFinishes
{
	while (is_saving_now) {}
}

- (void)userDicGotDirty
{
	is_dirty = true;
}

- (void)saverThread:(NSNull*)null_value
{
	is_dirty = false;
	is_saving_now = true;
	
	cout << "saving dictionary.." << endl;
	
	// t@CJ
	Dictionary& user_dic = SKKServer::sharedServer().getUserDic();
	//string dic_file = user_dic.getFilePath();
	//string dic_tmp_file = dic_file + ".tmp";
	//ofstream ofs(dic_tmp_file.c_str(),ios::out);
	
	bool terminated = false;
	try {
		//user_dic.save(ofs,flag_terminate_saving);
		user_dic.save(flag_terminate_saving);
	}
	catch (int e) {
		// IwoꂽB
		terminated = true;
		cout << "*** TERMINATED saving dictionary. ***" << endl;
	}
	//ofs.flush();
	//ofs.close();
	
	if (!terminated)
	{
		//rename(dic_tmp_file.c_str(),dic_file.c_str());
		cout << "saving dictionary has done." << endl;
	}
	
	is_saving_now = false;
	flag_terminate_saving = false;
}

- (void)terminateSaving
{
	if (is_saving_now)
	{
		flag_terminate_saving = true;
		while (flag_terminate_saving) {}
	}
}

@end
