/*  -*- c++ -*-
    $Id: Socket.h,v 1.1 2003/06/22 10:56:40 phonohawk Exp $
    ---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#pragma once
#include <string>
#include <stdio.h>
namespace net {
    class Socket;
}

class net::Socket {
private:
    std::string host;
    unsigned int port;
    
    bool listening;
    
    int fd;
    std::string overread; // ǂ݉߂
    
    bool eof;
    
    void connect();
    void begin_listening(int backlog);
    
public:
    // XjOړIł΁Ahost͋łǂB
    Socket(const std::string &host, unsigned int port,
	   bool listen = false, int listen_queue_size = 5);
    Socket(int fd);
    virtual ~Socket();
    
    bool hasGotEOF() const;
    void close();
    
    virtual Socket& operator<< (const std::string& str);
    virtual Socket& operator<< (const char* c_str);
    virtual Socket& operator<< (long n);
    virtual Socket& flush();
    
    virtual std::string readUntilCRLF();
    virtual std::string readline();
    virtual std::string readUntil(char ch);
    virtual int read();
    
    virtual Socket* accept();
    virtual int poll(bool* read,bool* write,bool* except,long timeout_ms) const;

    virtual int getPort() const;
    virtual std::string getpeername() const;
    virtual std::string getsockname() const;
};
