/*
	$Id: StringTokenizer.cpp,v 1.3 2002/11/29 12:23:04 phonohawk Exp $
	---------
	
    MacOS X implementation of the SKK input method.
    Copyright (C) 2002 phonohawk

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "StringTokenizer.h"
#include <string>
using namespace util;

StringTokenizer::StringTokenizer(const string& world,const string& delim)
	: world(world) , delim(delim) , pos(0)
{
	
}

StringTokenizer::~StringTokenizer()
{

}

bool StringTokenizer::hasMoreTokens()
{
	// posȍ~Ƀf~^łȂł݂trueB
	return world.find_first_not_of(delim,pos) != string::npos;
}

string StringTokenizer::nextToken()
{
	// posȍ~Af~^łȂ܂ŃXLbv
	unsigned int pos_not_delim = world.find_first_not_of(delim,pos);
	if (pos_not_delim == string::npos)
	{
		throw string("NoMoreTokensException");
	}
	
	// Ƀf~^ꏊT
	unsigned int pos_next_delim = world.find_first_of(delim,pos_not_delim+1);
	if (pos_next_delim == string::npos)
	{
		// Ō̃g[N
		pos = world.length();
		return world.substr(pos_not_delim,world.length() - pos_not_delim);
	}
	else
	{
		pos = pos_next_delim + 1;
		return world.substr(pos_not_delim,pos_next_delim - pos_not_delim);
	}
}
